package net.kldp.cats.core;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

/**
 *  (÷ ׷) Ÿ   (÷ ڸα׷)
 *   ϴ ڵ带 .
 * @author sjkim
 * @history 2006-08-11 ̻ --i = 1  ϴ° i=0  ϵ ħ
 * @history 2006-08-25 sjkim. ߻ Ŭ ٲ
 */
public abstract class ImageFeaturing {
  
	/**   */
  protected int size;
  
  /** ̸ Ʈ, ۹ȣ 1 */
  protected String[] fileList;
  
  /** 絵 ǥ, ۹ȣ 1*/
  protected double[][] simTab;
  
  /**
   * 絵   Ʈ д´.
   * @param fname  ̸ Ʈ()
   * @throws IOException  б 
   */
  public void read(String fname) throws IOException {
    FileReader fr = new FileReader(fname);
    BufferedReader br = new BufferedReader(fr);
    
    String aLine = null;
    int idx = 1;   
    aLine = br.readLine();
    size = Integer.parseInt(aLine);
    fileList = new String[size + 1]; //̹ ŭ Ҵ
    simTab = new double[size + 1][size + 1]; //̹  x ̹ ŭ Ҵ

    for (int i=0; i <= size; i++) {
      simTab[i] = new double[size + 1];
    }
    for (int i=1; i <= size; i++) {
      simTab[i][i] = 0.0;
    }
   
    while (null != (aLine=br.readLine())) {
      fileList[idx++] = aLine;
    }
    
    br.close();
    fr.close();
  }

  /**
   * 絵 ǥ Ϸ .
   * @param fname 絵 ǥ()
   * @throws IOException   
   * @history 2006-08-10 ̻
   * @history 2006-08-26 sjkim 1-based array
   */
  public void write(String fname) throws IOException {
    FileWriter fw = new FileWriter(fname);
    PrintWriter pw = new PrintWriter(fw);
    pw.println(size);
    for (int i = 1; i <= size; i++) {
      for (int j = i + 1; j <= size; j++) {
        pw.println(i + " " + j + " " + simTab[i][j]);
      }
    }
    pw.close();
    fw.close();    
  }
  
  /**
   * 絵 ϰ 絵 ǥ ϼѴ.
   */
  public abstract void compute();
  
  public abstract void compute(int numOfColor);  
  
  public abstract void compute(int Quanted ,int DISTANCE, int BAND);
}