package net.kldp.cats.core;

import java.io.FileWriter;
import java.io.PrintWriter;

/**
 * 
 * @author 
 * @history 2006-09-02
 * @history 2006-09-03 sjkim
 * (з ) ù   ׷찳  ׷ 
 * ٸ  ӽ÷ ƴ.
 *  ClusterNum  compute ޼ҵ带 ϸ ϴ  .
 */
public class SequentialClustering extends ImageClustering {
  float[] similarValue;
  float threshold;
  
  /** ӽ : sjkim */
  int backupClusterNum;
  
  private void setSimilarValue(){
    for (int i = 0; i < Data_Count - 1; i++) {
      if (SimilarData[i][i+1] >= 0) {
        similarValue[i] = SimilarData[i][i + 1];
      } else {
        similarValue[i] = SimilarData[i + 1][i];
      }
    }
  }
  
  public float findMax() {
    float tmpMax = 0;
    int tmpLoc = -1;
    for(int i = 0; i < Data_Count - 1; i++) {
      if (similarValue[i] > tmpMax) {
        tmpMax = similarValue[i];
        tmpLoc = i;
      }
    }
    similarValue[tmpLoc] = 0;
    return tmpMax;
  }
  
  public void compute(int num) { // sjkim
    if(num>0) ClusterNum=num;
    else ClusterNum =  FindClusterNum();
    backupClusterNum = ClusterNum; // sjkim
    
    similarValue = new float[Data_Count - 1];
    Cluster = new int[Data_Count];
    setSimilarValue();
    
    ClusterNum = num + 1; // sjkim
    
    for (int i = 0; i < ClusterNum - 1; i++) {
      threshold = findMax();
    }
    
		setSimilarValue();
		int tmpClusterStandard = 0;
    for (int i = 0; i < Data_Count; i++) {
      Cluster[i] = tmpClusterStandard;
      System.out.print(Cluster[i] + " ");
      if (i == Data_Count - 1) {
        break;
      }
      if (similarValue[i] > threshold) {
        tmpClusterStandard = i + 1;
      }
    }
  }
  
  /**
   * ӽ÷ ̵Ͽ.
   * ù ٿ  ׷찳  ׷  1  Ƽ
   * ½ Ͽ.
   */
  public void write(String File_Name) throws Exception {
    FileWriter File_Writer = new FileWriter(File_Name);
    PrintWriter Print_Writer = new PrintWriter(File_Writer);
    
    Print_Writer.println(backupClusterNum); // sjkim
    int check = 0;
    
    for(int i=0;i<Data_Count;i++){
      for(int j=0;j<Data_Count;j++){
        
        if((Cluster[j]) == i) {
          check = 1;
          Print_Writer.print(j+1+" ");
        }
      }
      if(check==1) {
        Print_Writer.println();
        check =0;
      }
    }
    
    Print_Writer.close();
    File_Writer.close();
    
    System.out.println("Output : " + File_Name);

  }
}
