package net.kldp.cats.ui.FileExplorer;

import javax.swing.*;
import javax.swing.filechooser.FileSystemView;
import javax.swing.tree.*;
import javax.swing.table.*;
import java.io.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

/**
 *  ý  Ʈ ش.
 * http://java.sun.com/products/jfc/tsc/articles/jtree/
 * @author Eric Armstrong, Tom Santos, Steve Wilson
 * @author sjkim
 * @history 2006-08-07
 * @history 2006-08-08   Ž 丮 Ʈó .
 * @history 2006-09-01 FileExplorer Ű ű.
 */
public class FileSystemTreePanel extends JPanel {
  private JTree tree;

  public FileSystemTreePanel() {
    this(new FileSystemModel());
  }

  public FileSystemTreePanel(String startPath) {
    this(new FileSystemModel(startPath));
  }

  public FileSystemTreePanel(FileSystemModel model) {
    tree = new JTree(model) {
      /** Ʈ  ̸ ش. */
      public String convertValueToText(Object value, boolean selected,
          boolean expanded, boolean leaf, int row,
          boolean hasFocus) {
        return ((FileSystemModel)treeModel).getSystemName((File)value);
      }
    };
  
    tree.setLargeModel(true);        
    tree.setRootVisible(true);
    tree.setShowsRootHandles(true);
    tree.putClientProperty("JTree.lineStyle", "Angled");
    
    setLayout(new BorderLayout());
    add(tree, BorderLayout.CENTER);
  }

  public JTree getTree() {
    return tree;
  }  
}