package net.kldp.cats.ui;

import java.awt.BorderLayout;
import java.io.File;
import java.io.IOException;

import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JEditorPane;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.text.html.HTMLDocument;
import javax.swing.text.html.HTMLFrameHyperlinkEvent;

/**
 * HTML ۼ  ȭ鿡 ֱ  Ŭ
 * @see JEditorPane
 * @author sjkim
 * @history 2006-08-18
 * @deprecated 2006-08-21 ũ ڹٽũƮ óϱ   . 
 */
public class HTMLViewer extends JFrame
                        implements HyperlinkListener {

  private static final long serialVersionUID = 1L;
  private JPanel jContentPane = null;
  private JScrollPane jScrollPane = null;
  private JEditorPane jEditorPane = null;

  /**
   * This is the default constructor
   */
  public HTMLViewer() {
    super();
    initialize();
  }

  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize() {
    this.setSize(820, 600);
    this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    this.setContentPane(getJContentPane());
    this.setTitle("");
  }

  /**
   * HTML  ȭ鿡 ش.
   * @param page HTML() ִ  
   */
  public void show(String page) {
    try {
      getJEditorPane().setPage("file:////" +
          (new File(page)).getAbsolutePath());
      setVisible(true);
    } catch (IOException e) {
      e.printStackTrace();
    }
  }

  /**
   * ũ  ±׸ óѴ.
   * @param e
   */
  public void hyperlinkUpdate(HyperlinkEvent e) {
    if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
      JEditorPane pane = (JEditorPane) e.getSource();
      if (e instanceof HTMLFrameHyperlinkEvent) {
        HTMLFrameHyperlinkEvent  evt = (HTMLFrameHyperlinkEvent)e;
        HTMLDocument doc = (HTMLDocument)pane.getDocument();
        doc.processHTMLFrameHyperlinkEvent(evt);
      } else {
        try {
          pane.setPage(e.getURL());
        } catch (Throwable t) {
          t.printStackTrace();
        }
      }
    }
  }

  /**
   * This method initializes jScrollPane	
   * 	
   * @return javax.swing.JScrollPane	
   */
  private JScrollPane getJScrollPane() {
    if (jScrollPane == null) {
      jScrollPane = new JScrollPane();
      jScrollPane.setViewportView(getJEditorPane());
    }
    return jScrollPane;
  }

  /**
   * This method initializes jEditorPane	
   * 	
   * @return javax.swing.JEditorPane	
   */
  private JEditorPane getJEditorPane() {
    if (jEditorPane == null) {
      jEditorPane = new JEditorPane();
      jEditorPane.setEditable(false);
      jEditorPane.addHyperlinkListener(this);
    }
    return jEditorPane;
  }

  /**
   * This method initializes jContentPane
   * 
   * @return javax.swing.JPanel
   */
  private JPanel getJContentPane() {
    if (jContentPane == null) {
      jContentPane = new JPanel();
      jContentPane.setLayout(new BorderLayout());
      jContentPane.add(getJScrollPane(), BorderLayout.CENTER);
    }
    return jContentPane;
  }
}
