package net.kldp.cats.ui;

import javax.swing.JPanel;

import java.awt.Cursor;
import java.awt.FlowLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

import net.kldp.cats.cats;

/**
 *  ڵ з ý ޴
 * .
 *  з, ̸ ,  ,  , 
 * .
 * ݵ setMain ޼ҵ带 MainFrame ü ȣؼ
 * MainFrame ü MenuPanel ؾ Ѵ.
 * @see MainFrame 
 * @author sjkim
 * @history 2006-08-16 
 * @history 2006-08-25 actionPerformed ޼ҵ忡 SwingWorker 
 * @history 2006-08-26 actionPerformed ޼ҵ忡  з ư  
 * 콺 Ŀ  ٲٰ α׷ ൿ ư ٽ  ϵ 
 * @history 2006-09-08  зϴ ư   ִ.
 * @history 2006-09-13 ÿϱ   ư   ֵ .
 */
public class MenuPanel extends JPanel
                       implements ActionListener {

  private static final long serialVersionUID = 1L;
  private JButton btnGrouping = null;
  private JButton btnRename = null;
  private JButton btnImport = null;
  private JButton btnDisplay = null;
  private JButton btnHelp = null;
  private MainFrame main;

  public MenuPanel() {
    super();
    initialize();
  }
  
  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize() {
    this.setLayout(new FlowLayout());
    this.setSize(new Dimension(600, 38));
    this.add(getBtnGrouping(), null);
    this.add(getBtnRename(), null);
    this.add(getBtnImport(), null);
    this.add(getBtnDisplay(), null);
    this.add(getBtnHelp(), null);
  }
  
  public void setMain(MainFrame frame) {
    main = frame;
  }

  /**
   * ư   
   * @author sjkim
   * @param e
   */
  public void actionPerformed(ActionEvent e) {
    JButton btn = (JButton) e.getSource();
    if (btn.equals(getBtnGrouping())) {
      getBtnGrouping().setEnabled(false);
      main.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
      SwingWorker sw = new SwingWorker() {
        public Object construct() {
          cats.runGroupingW(main);
          getBtnGrouping().setEnabled(true);
          main.setCursor(null);
          return null;
        }
      };
      sw.start();
    } else if (btn.equals(getBtnRename())) {
      System.out.println("rename");
      
    } else if (btn.equals(getBtnImport())) {
      System.out.println("import");
      
    } else if (btn.equals(getBtnDisplay())) {
      main.showImage(null);
      
    } else if (btn.equals(getBtnHelp())) {
      main.showHelp();
      
    }
  }

  /**
   * This method initializes btnGrouping	
   * 	
   * @return javax.swing.JButton	
   */
  private JButton getBtnGrouping() {
    if (btnGrouping == null) {
      btnGrouping = new JButton();
      btnGrouping.setText(" з");
      btnGrouping.addActionListener(this);
    }
    return btnGrouping;
  }

  /**
   * This method initializes btnRename	
   * 	
   * @return javax.swing.JButton	
   */
  private JButton getBtnRename() {
    if (btnRename == null) {
      btnRename = new JButton();
      btnRename.setText("̸ ");
      btnRename.setEnabled(false);
      btnRename.addActionListener(this);
    }
    return btnRename;
  }

  /**
   * This method initializes btnImport	
   * 	
   * @return javax.swing.JButton	
   */
  private JButton getBtnImport() {
    if (btnImport == null) {
      btnImport = new JButton();
      btnImport.setText(" ");
      btnImport.setEnabled(false);
      btnImport.addActionListener(this);
    }
    return btnImport;
  }

  /**
   * This method initializes btnDisplay	
   * 	
   * @return javax.swing.JButton	
   */
  private JButton getBtnDisplay() {
    if (btnDisplay == null) {
      btnDisplay = new JButton();
      btnDisplay.setText(" ");
      btnDisplay.setEnabled(false);
      btnDisplay.addActionListener(this);
    }
    return btnDisplay;
  }

  /**
   * This method initializes btnHelp	
   * 	
   * @return javax.swing.JButton	
   */
  private JButton getBtnHelp() {
    if (btnHelp == null) {
      btnHelp = new JButton();
      btnHelp.setText("");
      btnHelp.setEnabled(false);
      btnHelp.addActionListener(this);
    }
    return btnHelp;
  }
}
