package net.kldp.cats;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;

/**
 *  絵  з  ׷캰  ´.
 * @author sjkim
 * @history 2006 8 4
 */
public class MovePictures {

  /**
   * @param args
   * @throws Exceptions 
   */
  public static void main(String[] args) throws Exception {
    System.out.println(" ű");
    if (3 == args.length) {
      MovePictures mp = new MovePictures();
      mp.readFileList(args[0]);
      mp.readGroupList(args[1]);
      mp.move(args[2], null);      
    } else {
      System.out.println
      (" : java MovePictures ϸƮ() ׷츮Ʈ() ű丮");
    }
  }
  
  /**
   *  Ѵ.
   * @param src    ̸
   * @param dst   ̸
   * @throws IOException  н
   */
  public static void copyFile(String src, String dst) throws IOException {
    File inputFile = new File(src);
    File outputFile = new File(dst);
    
    FileInputStream in = new FileInputStream(inputFile);
    FileOutputStream out = new FileOutputStream(outputFile);
    int c;
    
    while ((c = in.read()) != -1) {
      out.write(c);
    }
    
    in.close();
    out.close();
  }
  
  private String[] fileList = null;
  private int[][] groupList = null;
  
  /**
   * ()ϸƮ д´.
   * @param fname ()ϸƮ()
   * @throws IOException   Ͽ.
   */    
  public void readFileList(String fname) throws IOException {
    FileReader fr = new FileReader(fname);
    BufferedReader br = new BufferedReader(fr);
    String aLine = null;
    int idx=1, size;
    aLine = br.readLine();
    size = Integer.parseInt(aLine);
    fileList = new String[size+1];
    while (null != (aLine=br.readLine())) {
      fileList[idx++] = aLine;
    }    
    br.close();
    fr.close();
  }
  
  /**
   * з  (׷츮Ʈ) д´.
   * @param fname ׷츮Ʈ()
   * @throws IOException   Ͽ.
   */
  public void readGroupList(String fname) throws IOException {
    FileReader fr = new FileReader(fname);
    BufferedReader br = new BufferedReader(fr);
    String aLine = null;
    int idx=1, size, group;
    StringTokenizer st = null;
    aLine = br.readLine();
    size = Integer.parseInt(aLine);
    groupList = new int[size][];
    group = 0;
    while (null != (aLine=br.readLine())) {
      st = new StringTokenizer(aLine);
      if (st.hasMoreTokens()) {
        groupList[group] = new int[st.countTokens()];
      }
      int i = 0;
      while (st.hasMoreTokens()) {
        groupList[group][i++] = Integer.parseInt(st.nextToken());
      }
      group++;
    }    
    br.close();
    fr.close();    
  }
  
  /**
   * ()ϸƮ ׷츮Ʈ  д  Ѵ.
   */
  public void print() {
    if (null != fileList) {
      for (int i = 0; i < fileList.length; i++) {
        System.out.println(i + ":" + fileList[i]);
      }
    }
    if (null != groupList) {
      for (int i = 0; i < groupList.length; i++) {
        for (int j = 0; j < groupList[i].length; j++) {
          System.out.print(groupList[i][j]+" ");
        }
        System.out.println();
      }
    }
  }
  
  /**
   *   ϰų ̵Ѵ.
   *  ΰ      .
   * @param dir ۾丮
   * @param param û : ̵, 
   */
  public void move(String dir, String param) {
    File workingDir, subDir, file;
    workingDir = new File(dir);
    if (!workingDir.isDirectory()) {
      System.out.println(dir + " 丮 ƴմϴ.");
      workingDir = new File(System.getProperty("user.dir"));
    }
    
    if (null != groupList) {
      for (int i = 0; i < groupList.length; i++) {
        subDir = new File(workingDir, "group" + i);
        subDir.mkdir();
        for (int j = 0; j < groupList[i].length; j++) {
/////////////////////////////////////////////////////////////////////////////
// DEBUG
//          System.out.println(fileList[groupList[i][j]] + " " +
//              subDir.getAbsolutePath() + "\\" + fileList[groupList[i][j]]);
/////////////////////////////////////////////////////////////////////////////
          try {
            file = new File(fileList[groupList[i][j]]);
            MovePictures.copyFile(fileList[groupList[i][j]],
                subDir.getAbsolutePath() + File.separator +
                file.getName());
          } catch (IOException e) {
            e.printStackTrace();
          }
        }
        System.out.println();
      }
    }
  }

}
