package net.kldp.cats.core;
import java.awt.Frame;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.awt.image.Raster;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.StringTokenizer;


/*
 * ڸα׷ ˰ 
 *  
 * @input1,2 : Read_Image_Gen_DB    ,
 * @arg : ȭ   ex) 64
 * @output: result.out -  ̹ 絵 double ǥ (0   )
 *  
 */
public class Correlogram_method {


	int quant_color ; //ȭ ÷ 
	double sim = 0; // 絵
	int num = 0; // ߺǴ ȼ 

	int data2D_1[][]; //̹1   ϴ 迭 
	int data2D_2[][];//̹2   ϴ 迭
	double correlogram1[][];//̹1 ڸα׷  ϴ 迭  
	double correlogram2[][]; //̹2 ڸα׷  ϴ 迭
	int width;
	int height;
	//	FileWriter fw;
		//PrintWriter pw ;
		
		FileReader fr1 ;
		// BufferedReader br1 ;
		 FileReader fr2 ;
		// BufferedReader br2 ;
		 
		 /*
		  * 
		  */
		Correlogram_method(String filename1,String filename2,int c)throws Exception
		{
			quant_color = c;
			fr1 = new FileReader(filename1);
			fr2 = new FileReader(filename2);
		//	fw = new FileWriter("result.out");
		//	pw = new PrintWriter(fw);
			
			data2D_1 = read(fr1); //̹1  1 ޾ƿ   
			correlogram1 = cal_correlogram(data2D_1,quant_color); //̹1 ڸα׷ 
			data2D_2 = read(fr2); //̹2  2 ޾ƿ
			correlogram2 = cal_correlogram(data2D_2,quant_color); //̹2 ڸα׷ 
			
			 cal_auto_correlogram(correlogram1,correlogram2,4,quant_color); //k=1,3,5,7 ; color = 64  ڸα׷  
			
		//	pw.close(); fw.close();
			fr1.close(); fr2.close();
		}
		
		Correlogram_method(String filename1,int c)throws Exception
		{
			quant_color = c;
			// fr1 = new FileReader(filename1);
			
			// data2D_1 = read(fr1); //̹1  1 ޾ƿ
            data2D_1 = quantize(filename1);
			correlogram1 = cal_correlogram(data2D_1,quant_color); //̹1 ڸα׷ 
			// fr1.close();
		}
        
        public int[][] quantize(String fname) {
          int[][] data;
          Quantization quant = QuantizationFactory.makeSimpleQuantization(4, 4, 4); //64 color
          BufferedImage bi = readImage(fname);
          width = bi.getWidth();
          height = bi.getHeight();
          int[][] red = readData(bi, 0);
          int[][] green = readData(bi, 1);
          int[][] blue = readData(bi, 2);
          data = new int[height][width];

          for (int r = 0; r < height; r++) {
            for (int c = 0; c < width; c++) {
              data[r][c] = quant.table[quant.channel1st[red[r][c]]]
                              [quant.channel1st[green[r][c]]]
                              [quant.channel1st[blue[r][c]]];
            }
          }
          return data;
        }
        private static BufferedImage readImage(String fname) {
          Frame frame = new Frame();
          Image im = Toolkit.getDefaultToolkit().getImage(fname);
          try {
            MediaTracker mt = new MediaTracker(frame);
            mt.addImage(im, 0);
            mt.waitForID(0);
          } catch (Exception e) {}
          BufferedImage bi = new BufferedImage(im.getWidth(frame),
              im.getHeight(frame),
              BufferedImage.TYPE_INT_RGB);
          bi.createGraphics().drawImage(im, 0, 0, null);
          return bi; 
        } 
        
        /**
         * ̹ о Ư  ȼ  .
         * @param im ⺻ ̹ Ŭ
         * @param band    ϳ. , RGB (:0~2)
         * @return 2 ȼ 
         */
        public static int[][] readData(BufferedImage im, int band) {
          Raster ra = null;
          int data1D[] = null;
          int data2D[][] = null;
          int w, h;
          ra = im.getData();
          w = ra.getWidth();
          h = ra.getHeight();
          data1D = new int[w*h];
          ra.getSamples(0,0,w,h,band,data1D);
          data2D = new int[h][];
          for (int i=0; i<h; i++) {
            data2D[i] = new int[w];
          }
          for (int r=0; r<h; r++) {
            for (int c=0; c<w; c++) {
              data2D[r][c] = data1D[r*w+c];
            }
          }
          return data2D;
        }

		
		Correlogram_method(int c)throws Exception
		{
			quant_color = c;
			//fr1 = new FileReader(filename1);
			
			//data2D_1 = read(fr1); //̹1  1 ޾ƿ   
			//correlogram1 = cal_correlogram(data2D_1,quant_color); //̹1 ڸα׷ 
			//fr1.close();
			
		}
		
		public int[][] read(FileReader fr) throws Exception {
			
			BufferedReader br = new BufferedReader(fr);
		    String aLine = null;
		    StringTokenizer st = null;
		    aLine = br.readLine();
		 
		    int data2D[][];  // ̹   2迭
		    
		    int r = 0, c =0;
		    width = Integer.parseInt(aLine);
		    height = Integer.parseInt(aLine=br.readLine());
		    
		    System.out.println("̹ :"+height+"x"+width);
		    data2D = new int[height][width]; //̿ ̸ŭ 迭
		    while (null != (aLine=br.readLine())) {
		    	st = new StringTokenizer(aLine);
		    			c=0;
			 			while (st.hasMoreTokens()) {
			 				data2D[r][c] = Integer.parseInt(st.nextToken());
			 			c++;
			 		   	}
			 		r++;		
			 	}	
			 br.close();
			 fr.close();	
		    
			 return data2D;
		}
		
		/*
		 * @ param1 : ̹  (迭) 
		 * @ param2  : ȭ   (32,64,128, 256,...) 
		 * @ return : ̹ ڸα׷  (迭)
		 * */
		double[][] cal_correlogram(int data2D[][],int Num_Color) 
		{
			final int Num_Distance = 4;// D = 1,3,5,7   
			double correlogram_data[][] = new double [Num_Distance][Num_Color]; //data2D  correlogram   2D array
			
			

			// ڸα׷(r)  
			//j>0, width>j, height>i, i>0
			int  cor_column_start = 0, cor_column_end = 0;
			int  cor_row_start=0, cor_row_end =0;
			int dis = 0;
			for(int D =0; D< Num_Distance; D++) // Ÿ 1, 3 ,5 7ؿ ó 
			{
				if(D==0)
					dis =1;
				else if(D==1)
					dis =3;
				else if(D==2)
					dis =5;
				else if(D==3)
					dis =7;
				
			
				for(int  Current_Color=0; Current_Color< Num_Color; Current_Color++){	//64  ؼ ó
					 correlogram_data[D][Current_Color] = 0; //    ڸα׷  迭 ʱȭŴ
					 int total_pixel = 1; // ÷ Ÿ dis   ȼ  ϴ  ʱȭ
					 int same_pixel =  0;
					 for(int r = 0 ; r< height; r++){
						cor_row_start = r-dis;
						cor_row_end = r + dis;
						
						for(int c = 0 ; c< width; c++){	
							 cor_column_start = c-dis; 
							 cor_column_end = c+dis;
							if(data2D[r][c]==Current_Color) 
							 for(int current_row = cor_row_start; current_row <=cor_row_end; current_row++){
								 if(current_row>=0&&current_row <height) //ȼ ġ  0 ۰ų ̺ ũ  
								 {
									 for(int current_column = cor_column_start; current_column <=cor_column_end; current_column++) 
									 {
										 if(current_column>=0&&current_column <width) //ȼ ġ 0 ۰ų ̺ ũ ȵ
									 
											 if(Math.abs(current_row-r)==dis||Math.abs(current_column-c)==dis){ // (r,c)ȼ dis Ÿŭ  ȼ  Ȯ	 
												 total_pixel++; // Ÿ dis ִ ȼ 1 Ŵ
												 	if(data2D[current_row][current_column]==Current_Color){ // Ÿ dis  ִ ȼ ÷   ȼ  
												 		same_pixel++;//   1ŭ Ŵ
											 	}
											 }
									 }
								 }
							 }
							 					 
						} //end of for(int c; width )
						
					} //end of for(int r;..
					correlogram_data[D][Current_Color]=(double)same_pixel/total_pixel;
//					System.out.println("K="+dis+"["+Current_Color+"]"+correlogram_data[D][Current_Color]);
				} //end of for (color)
				
			}//end of for(distance)
			System.out.println("\nڸα׷  ");
			return correlogram_data;
		}
		
		
		
		/*
		 * Auto-Correlogram
		 * @param1 : ̹1 ڸα׷ , 2 迭 
		 * @param2 : ̹2 ڸα׷ , 2 迭
		 * @param3 : ŸK  (k=4 ; 1,3,5,7) 
		 * @param4: ȭ    (32,64,128,256,....)
		 * @return ;  ̹   ȯ( 0    ̹)
		 *
		 *Ÿ: 1,3,5,7 ; : ȭ (64)
		 *equation : I = sigma |r-r'| / (r+r'+1) 
		 */
		double cal_auto_correlogram(double correlogram_data1[][],double correlogram_data2[][],int Num_Distance,int Num_Color){
			sim = 0.0; //reset
			double I = 0; // |I-I'|
			double a = 0;
			
			 for(int D =0; D < Num_Distance ; D++)
			 {
			 for(int Current_Color =0; Current_Color< Num_Color; Current_Color++)
				 {//I = (Math.abs(correlogram_data1[D][Current_Color]-correlogram_data2[D][Current_Color])) / (correlogram_data1[D][Current_Color]+correlogram_data2[D][Current_Color]+1);
				 I = (Math.abs(correlogram_data1[D][Current_Color]-correlogram_data2[D][Current_Color])); //
				 a = (correlogram_data1[D][Current_Color]+correlogram_data2[D][Current_Color]+1); //и
				 sim+=I/a;
				 }
			
			 }
		System.out.println("絵 (0  )="+sim);
		return sim;
		}
		void write_correlogram(double data[][]) throws Exception
		{
			//FileWriter fw;
		//	PrintWriter pw ;
			//fw = new FileWriter("");
			//pw = new PrintWriter(fw);
			
		}
		
		public double write_sim(double result) 
		{
			
			//pw.println(result);
		
			
			return result;
		}
		


}
