package net.kldp.cats.core;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.StringTokenizer;

/**
 * Clustering Ŭ
 * @author 
 *
 */
public class ImageClustering {
	int Data_Count;
	float SimilarData[][];
	int Cluster[];
	int ClusterNum;

	/**
	 * 絵  б
	 * @param File_Name 絵 ϸ
	 * @throws Exception
	 */
  public void read(String File_Name) throws Exception {
		StringTokenizer st = null;
		System.out.println("Input : " + File_Name);
	
		FileReader File_Reader = new FileReader(File_Name);
		BufferedReader Buffer_Reader = new BufferedReader(File_Reader);
		
		String LineTmp = null;
		
		LineTmp = Buffer_Reader.readLine();
		Data_Count = Integer.parseInt(LineTmp);
		String[] StrTmp = new String[Data_Count];
		SimilarData = new float[Data_Count][Data_Count];
		int count = 0, tmp_i=0, tmp_j=0;
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++){
				SimilarData[i][j] = -1;
			}
		}
		while((LineTmp = Buffer_Reader.readLine())!=null){
			count = 0;
			
			st  = new StringTokenizer(LineTmp);
			while(st.hasMoreTokens()){
				StrTmp[count] = st.nextToken();
				count++;
			}

			
			tmp_i = Integer.parseInt(StrTmp[0])-1;
			tmp_j = Integer.parseInt(StrTmp[1])-1;
			SimilarData[tmp_i][tmp_j] = Float.parseFloat(StrTmp[2]);

		}
		File_Reader.close();
		Buffer_Reader.close();
  }

  /**
   * Ŭ 
   * @param File_Name Ŭ ϸ
   * @throws Exception
   */
  public void write(String File_Name) throws Exception {
		
	    FileWriter File_Writer = new FileWriter(File_Name);
	    PrintWriter Print_Writer = new PrintWriter(File_Writer);
	    
	    Print_Writer.println(ClusterNum);
	    int check = 0;
	    
	    for(int i=0;i<Data_Count;i++){
	    	for(int j=0;j<Data_Count;j++){
	    		
	    		if((Cluster[j]) == i) {
	    			check = 1;
	    			Print_Writer.print(j+1+" ");
	    		}
	    	}
	    	if(check==1) {
	    		Print_Writer.println();
	    		check =0;
	    	}
	    }
	    
	    Print_Writer.close();
	    File_Writer.close();
	    
	    System.out.println("Output : " + File_Name);
  }

  /**
   * Ŭ͸
   * @param numOfClusters Ŭ 
   * @throws Exception
   */
  public void compute(int numOfClusters) throws Exception {
    //OVERRIDE
  }

  /**
   * Ŭ͸
   * @param numOfClusters Ŭ 
   * @param option
   */
  public void compute(int numOfClusters, int option) throws Exception {
    //OVERRIDE
  }
  
  /**
   * Ŭ͸ ⿡   ϱ
   * @return  Ŭ 
   */
  protected int FindClusterNum(){
    float Sum=0, Threshold=0;
    int count=0, Num=0;
    for(int i=0;i<Data_Count;i++){
      for(int j=0;j<Data_Count;j++){
        if(SimilarData[i][j]>=0){
          Sum = Sum + SimilarData[i][j];
          count++;
        }
      }
    }
    Threshold =  Sum / count;
    
    for(int i=0;i<Data_Count;i++){
      for(int j=0;j<Data_Count;j++){
        if(Num >= Data_Count){
//          System.out.println("Ӱ谪(Threshold) ʹ ۽ϴ.  ũ  ּ.");
          return Data_Count;
        }

        if(SimilarData[i][j]>Threshold) Num++;
      }
    }
  
    if(Num <= 1){
//      System.out.println("Ӱ谪(Threshold) ʹ Ůϴ.  ۰  ּ.");
      return Data_Count;
    }
    else return Num;
  }
}
