package net.kldp.cats.core;

import java.io.*;

import java.util.StringTokenizer;

/**
 * @deprecated 2006-08-21
 */
public class MST {
	float[][] InFile;	//  ̺ ϰ ִ 迭
	float[][] UpdateFile_1;	// Ʈ Ǹ鼭 ϴ 迭 
	float[][] UpdateFile_2;
	
	int[][] store_temp;	//Ȯ 
	int[] store_i;	 
	int[] store_j;	 
	int averNum;	// ׷쿡 Ƚ  
	
	float g_average;
	float g_stand;
	//float Average;	// ü  
	
	int[] File_Id;	// Ŭ͸  ID
	int size;
	int g_size;	//    ϴ  
	float temp;
	int Min_i,Min_j;
	
    String inputFile = null;
    String outputFile = null;
	
    public MST(int cal_size, String input, String output) throws Exception {
        inputFile = input;
        outputFile = output;
        g_size = cal_size;
        // simul_ouptut о
        readFile();
        
        UpdateFile_1 = new float[size][size];
        UpdateFile_2 = new float[size][size];
        
        // ۾   α 
        for(int i=0;i<size;i++){
            for(int j=0;j<size;j++)
            {
                UpdateFile_1[i][j] = InFile[i][j];              
            }
        }   
        
        //  ϴ ׷ ŭ Ű 
        for(int i = size; i > cal_size; --i)
        {
            find_Min();
            make_Table(Min_i,Min_j);    
            
        }
        
        //  ܼȭ Ͽ ϱ 
        printFile();
        accuracy_Check();        
    }
	//  
	public MST(int cal_size) throws Exception {
		
		g_size = cal_size;
		// simul_ouptut о
		readFile();
		
		UpdateFile_1 = new float[size][size];
		UpdateFile_2 = new float[size][size];
		
		// ۾   α 
		for(int i=0;i<size;i++){
			for(int j=0;j<size;j++)
			{
				UpdateFile_1[i][j] = InFile[i][j];				
			}
		}	
		
		//	ϴ ׷ ŭ Ű 
		for(int i = size; i > cal_size; --i)
		{
			find_Min();
			make_Table(Min_i,Min_j);	
			
		}
		
		//  ܼȭ Ͽ ϱ 
		printFile();
		accuracy_Check();
		
		
		//cal_Average();
		
		
		
		
	}
	
	public void cal_Average(int cmp_i,int cmpNum) throws Exception{
				
		store_i = new int[cmpNum] ;
		store_j = new int[cmpNum];
		int setCnt = 0;
	
		g_average = -3;
		g_stand = -3;
		if(cmpNum != 0)
		{
			if(cmpNum == 1)
			{
				System.out.println("0.0");
				g_average = 0;
				g_stand = 0;
			}
			else if(cmpNum > 1)
			{
				for(int j=0;j<size;j++){
				if(store_temp[cmp_i][j] !=0){
					store_i[setCnt] = store_temp[cmp_i][j];
					setCnt++;
					}
				}
				averNum=0;
				for(int i =0;i<setCnt;i++)
				{
					
					averNum +=i;
					store_j[i]=store_i[i];
					System.out.println(store_j[i]);
				}
				float sum=0;	//  
				float standSum=0;	// ǥ 
				for(int i=0;i<setCnt;i++){
					for(int j=0;j<setCnt;j++){
						if(i < j){
							//sum =0;
							sum += InFile[store_i[i]-1][store_j[j]-1];
							standSum += InFile[store_i[i]-1][store_j[j]-1]*InFile[store_i[i]-1][store_j[j]-1];
							System.out.println(store_i[i]+" "+store_j[j]+" "+sum);
							//++System.out.println(store_i[i]+" "+store_j[j]+" "+standSum);
							g_average = sum;
							g_stand = standSum;
							//System.out.println("׷  : "+setCnt+" "+"׷:"+g_average);
						}
					}
				}
			}
		}
		else{
			System.out.println("-1.0");
			g_average = -3;
		}
}	
	
	
	public void accuracy_Check() throws Exception{
		
		int cmpNum=0;
		int cmp_i=0;
		float average_temp=0;
		float stand_temp=0;
		float total_average=0;
		float total_stand = 0;
		//float Average = 0;
		for(int i=0;i<size;i++){
			cmpNum=0;
			for(int j=0;j<size;j++){
				if(store_temp[i][j] != 0){
					cmp_i=i;
					cmpNum ++;
				}
			}
			//++System.out.println(cmpNum);	
			//++System.out.println(" ");
			cal_Average(cmp_i,cmpNum);
			average_temp = g_average;
			stand_temp = g_stand;
			//System.out.println("׷ոϰ");
			if((average_temp > 0) && (stand_temp > 0))
			{
				average_temp = average_temp/averNum;	// ׷ 
				stand_temp = (float) Math.sqrt(stand_temp/averNum - average_temp*average_temp);	// ׷ ǥ
				System.out.println(" ׷  : "+average_temp);
				total_average += average_temp;
				System.out.println(" ׷  : "+stand_temp);
				total_stand +=stand_temp;
			}
			
		}
		//++System.out.println(total_average);
		System.out.println("====================");
		System.out.print("   : ");
		total_average = total_average/g_size;
		total_stand = total_stand/g_size;
		System.out.println(total_average);
		System.out.print(" ǥ  : ");
		System.out.println(total_stand);
		//Average = total_average;
}
	
	//   ϴ Լ  
	public void printFile() throws Exception{
		
		FileWriter fw =  new FileWriter(outputFile); // ("clustering_output.txt");
		PrintWriter pw = new PrintWriter(fw);
		
		System.out.println("< Minimum Spannig Tree Clustering >");
		System.out.println("  "+size);
        // pw.println(size);
        pw.println(g_size);
		
		for(int i=0;i<size;i++){
			for(int j=0;j<size;j++){
				
				System.out.print(" "+UpdateFile_2[i][j]);	//	ܼȭ鿡  
				
			}
			System.out.println();			
		}
		
		System.out.println();
		System.out.print("File_Id : ");
		
		// File_Id ü ֱ 
		for(int i=0;i<size;i++)
		{
			System.out.print(File_Id[i]+" ");
		}	
		System.out.println();
		
		
		//  ׷ 
		store_temp= new int[size][size];
		System.out.println();
		int Id_count=0;
		for(int i=0;i<size;i++){
			Id_count=0;
			for(int j=0;j<size;j++){
				
				if(File_Id[j]==i)
				{
					System.out.print((j+1)+" ");
					pw.print((j+1)+" ");
					store_temp[i][j]=j+1;	// Ȯ    ʿ 迭 

					Id_count++;
					
				}
				
			}
			
			if(Id_count != 0)
			{
				System.out.println();
				pw.println();
				
			}
			continue;
		}
		//pw.println(Average);
		System.out.println();
		System.out.println(" Clutering Process End !!! ");
		
		for(int i=0;i<size;i++){
			for(int j=0; j<size;j++){
				System.out.print("  "+store_temp[i][j]);
				}
			System.out.println();
		}
				
		pw.close();
		fw.close();
	}
	
	public void cal_Standard() throws Exception{
		
	}
	
	
	
	
	//  о Լ 
	public void readFile() throws Exception{
		StringTokenizer st = null;
		FileReader fr = new FileReader(inputFile);// ("simul_output.txt");
		BufferedReader br = new BufferedReader(fr);
		
		String file_num = null;
		file_num = br.readLine();
		size = Integer.parseInt(file_num);
		
		//   ߶  ϴ κ 
		String file_token = null;
		int counter;
		String [] StrTmp;
		StrTmp = new String[3];
		int tmp_i,tmp_j;
		InFile = new float[size][size];
		
		// InFile  迭  -1 ʱȭ 
		for(int i = 0;i<size;i++){			 
			for(int j = 0;j<size;j++)
			{
				InFile[i][j]= -1;
			}
		}		
				
		// شϴ  迭  
		while((file_token = br.readLine()) != null)
		{
			counter=0;
			st = new StringTokenizer(file_token);
			while(st.hasMoreTokens())
			{
				StrTmp[counter] = st.nextToken();
				counter++;
			}
			
			tmp_i = Integer.parseInt(StrTmp[0])-1;
			tmp_j = Integer.parseInt(StrTmp[1])-1;
			InFile[tmp_i][tmp_j] = Float.parseFloat(StrTmp[2]);		
			
		}
		
		File_Id = new int[size];
		for(int k=0;k<size;k++){
			File_Id[k] = k; 	// Ŭ͸ ID
		}
		
		br.close();
		fr.close();
	
						
	}
	
	// ּҰ ãƳ Լ 
	public void find_Min() throws Exception{
		
		float stand = 0;		
		int stand_i =0;
		int stand_j=0;		
		
		for(int i=0;i<size;i++){
			for(int j=0;j<size;j++)
			{				
				UpdateFile_2[i][j] = UpdateFile_1[i][j];
				
			}
		}	
		
		// ּҰ ãƳ  ⺻ ϱ 
		for(int i=0;i<size;i++){
			for(int j=0;j<size;j++)
			{	
							
				if(UpdateFile_2[i][j] >= 0)
				{
					
					stand = UpdateFile_2[i][j];
					stand_i = i;
					stand_j = j;
					break;
				}
			
			}
			
			if(stand != 0)
				break;
		}
		
		Min_i= stand_i;
		Min_j = stand_j;

		// ּҰ ش 迭ּ  
		for(int i = 0; i <size ;i++){
			for(int j = 0;j<size;j++)
			{				
				if(UpdateFile_2[i][j] != -1.0 && UpdateFile_2[i][j] !=-2.0)
				{
					
					if(stand > UpdateFile_2[i][j])
					{
						
						stand = UpdateFile_2[i][j];												
						Min_i = i;
						Min_j = j;
					
					}
									
				}
				
			}
		}
		
		//  ׷ File_Id ϳ  ֱ 
		for(int i = 0; i<size; i++)
			if(File_Id[i] == Min_i)
				File_Id[i] = Min_j;
	
		
	}
	
	// ̺   Լ 
	public void make_Table(int select_i, int select_j) throws Exception{
				
		for(int i=0;i<size;i++){
			for(int j=0;j<size;j++)
			{
				// -1 ƴ ͸ üũ 
				if(UpdateFile_2[i][j]!= -1.0)
				{
					if(i == select_i)
						UpdateFile_2[i][j]= (float)-2.0;	
															
					if(j == select_i)
						UpdateFile_2[i][j]= (float)-2.0;
										
				}	
			}
		}
		
		for(int i=0;i<size;i++){
			for(int j=0; j<size;j++){
				if(UpdateFile_2[i][j]!= -1.0 && UpdateFile_2[i][j]!=-2.0)
				{
					if(j == select_j)
						UpdateFile_2[i][j] = (UpdateFile_1[i][select_i] + UpdateFile_1[i][select_j])/2;
						
					
					if(i == select_j)
						UpdateFile_2[i][j]  = (UpdateFile_1[select_i][j] + UpdateFile_1[select_j][j])/2;
						
				}
			}
		}
				
		for(int i=0;i<size;i++){
			for(int j=0;j<size;j++)
			{
				UpdateFile_1[i][j] = UpdateFile_2[i][j];
			}
		}
		
		
		
		
	}
	
	
	public static void main(String[] args) throws Exception {
		int g_limit = 27;
		//ClusterTest first = new ClusterTest(g_limit);
        if (3 == args.length) {
          MST first = new MST(Integer.parseInt(args[0]), args[1], args[2]);
        }
		
	
	}

}
