package net.kldp.cats.core;

/**
 * θ class ӹ޾ Minimum Spanning Tree Algorithm  غ clustering
 * @author hjsong.photo-cats
 * @history 2006-09-03 sjkim
 * ǻƮ ޼ҵ忡 ϴ ɼ (MEAN, SHORT, LONG) ߰
 */
public class MSTClustering extends ImageClustering{
	
  public static final int MEAN = 1;
  public static final int SHORT = 2;
  public static final int LONG = 3;
  
	float[][] UpdateFile_1;	// Ʈ Ǹ鼭 ϴ 迭 
	float[][] UpdateFile_2;
	
	int[][] store_temp;	//Ȯ 
	int[] store_i;	 
	int[] store_j;	 
	int averNum;	// ׷쿡 Ƚ  
	
	float g_average;
	float g_stand;
	
	float temp;
	int Min_i,Min_j;
	
	int Cluster_option;	// Ŭ͸ ϴ   

	public MSTClustering() {
		Cluster_option = 1;
	}
	/**
	 *  ˰  (overide) 
	 */
	public void compute(int numOfClusters) throws Exception{
    if(numOfClusters>0) ClusterNum=numOfClusters;
    else ClusterNum =  FindClusterNum();  
    
		Cluster = new int[Data_Count];
		for(int k=0;k<Data_Count;k++){
			Cluster[k] = k; 	// Ŭ͸ ID
		}
		
		ClusterNum = numOfClusters;
		
		UpdateFile_1 = new float[Data_Count][Data_Count];
		UpdateFile_2 = new float[Data_Count][Data_Count];
		
		//	۾   α 
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++)
			{
				UpdateFile_1[i][j] = SimilarData[i][j];				
			}
		}
		
		
		if(Cluster_option == 1)
		{
			//	 ϱ  
			for(int i = Data_Count; i > ClusterNum; --i){
				find_Min();			
				make_Table(Min_i,Min_j);	
				}
		}
		else if(Cluster_option == 2)
		{
			//	ּҰ ϱ 
			for(int i = Data_Count; i > ClusterNum; --i){
				find_Min();			
				make_Table_using_MIN(Min_i,Min_j);	
				}
		}
		else if(Cluster_option == 3)
		{
			//	ִ밪 ϱ  
			for(int i = Data_Count; i > ClusterNum; --i){
				find_Min();			
				make_Table_using_MAX(Min_i,Min_j);	
				}
		}
		
		System.out.println(Data_Count);
		store_temp= new int[Data_Count][Data_Count];
		int Id_count=0;
		for(int i=0;i<Data_Count;i++){
			Id_count=0;
			for(int j=0;j<Data_Count;j++){
				if(Cluster[j]==i)
				{
					System.out.print((j+1)+" ");
					store_temp[i][j]=j+1;	// Ȯ    ʿ 迭 
					Id_count++;
				}
			}
			if(Id_count != 0)
			{
				System.out.println();
			}
			continue;
		}
////////////////////////////////////////////////////////////
// DEBUG
//		accuracy_Check();
////////////////////////////////////////////////////////////
		System.out.println(" >>> Clutering Process End !!! ");
		
	}

	/**
	 * option   compute override
	 */
	public void compute(int numOfClusters, int option) throws Exception{
		
		Cluster_option = option;
		switch(Cluster_option)
		{
		case 1: 
			System.out.println(" ѰԴϴ."); 
			compute(numOfClusters); 
			break;
		
		case 2: 
			System.out.println("ּҰ ѰԴϴ."); 
			compute(numOfClusters);
			break;
			
		case 3: 
			System.out.println("ִ밪 ѰԴϴ.");
			compute(numOfClusters);
			break;
		
		default: System.out.println("error");
		}
	}
	/**
	 * 絵 ǥ ߿ ּҰ ã´.
	 * @throws Exception
	 */
	public void find_Min() throws Exception{
		
		float stand = 0;		
		int stand_i =0;
		int stand_j=0;		
		
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++)
			{				
				UpdateFile_2[i][j] = UpdateFile_1[i][j];
								
			}
		}	
		// ּҰ ãƳ  ⺻ ϱ 
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++)
			{	
							
				if(UpdateFile_2[i][j] >= 0)
				{
					
					stand = UpdateFile_2[i][j];
					stand_i = i;
					stand_j = j;
					break;
				}
			
			}
			
			if(stand != 0)
				break;
		}
		
		Min_i= stand_i;
		Min_j = stand_j;

		// ּҰ ش 迭ּ  
		for(int i = 0; i <Data_Count ;i++){
			for(int j = 0;j<Data_Count;j++)
			{				
				if(UpdateFile_2[i][j] != -1.0 && UpdateFile_2[i][j] !=-2.0)
				{
					
					if(stand > UpdateFile_2[i][j])
					{
						
						stand = UpdateFile_2[i][j];												
						Min_i = i;
						Min_j = j;
					}
									
				}
				
			}
		}
	
		//	 ׷ File_Id ϳ  ֱ 
		for(int i = 0; i < Data_Count; i++){
			if(Cluster[i] == Min_i)
			{
				Cluster[i] = Min_j;

				//System.out.println(Cluster[i]+" ");
			}
		}
		
	}
	/**
	 * ּҰ ã  հ renewalǴ ̺  .
	 * @param select_i ּҰ ִ  ּ
	 * @param select_j ּҰ ִ  ּ 
	 * @throws Exception
	 */
	public void make_Table(int select_i, int select_j) throws Exception{
				
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++)
			{
				// -1 ƴ ͸ üũ 
				if(UpdateFile_2[i][j]!= -1.0)
				{
					if(i == select_i)
						UpdateFile_2[i][j]= (float)-2.0;	
															
					if(j == select_i)
						UpdateFile_2[i][j]= (float)-2.0;
										
				}	
			}
		}
		
		for(int i=0;i<Data_Count;i++){
			for(int j=0; j<Data_Count;j++){
				if(UpdateFile_2[i][j]!= -1.0 && UpdateFile_2[i][j]!=-2.0)
				{
					if(j == select_j)
						UpdateFile_2[i][j] = (UpdateFile_1[i][select_i] + UpdateFile_1[i][select_j])/2;
						
					
					if(i == select_j)
						UpdateFile_2[i][j]  = (UpdateFile_1[select_i][j] + UpdateFile_1[select_j][j])/2;
						
				}
			}
		}
				
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++)
			{
				UpdateFile_1[i][j] = UpdateFile_2[i][j];
			}
		}
		
	}
	
	/**
	 * ּҰ ã   ̹  ּҰ(MIN) renewalǴ ̺  .
	 * @param select_i ּҰ ִ  ּ
	 * @param select_j ּҰ ִ  ּ
	 * @throws Exception
	 */
	public void make_Table_using_MIN(int select_i, int select_j) throws Exception{
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++)
			{
				// -1 ƴ ͸ üũ 
				if(UpdateFile_2[i][j]!= -1.0)
				{
					if(i == select_i)
						UpdateFile_2[i][j]= (float)-2.0;	
															
					if(j == select_i)
						UpdateFile_2[i][j]= (float)-2.0;
										
				}	
			}
		}
		
		for(int i=0;i<Data_Count;i++){
			for(int j=0; j<Data_Count;j++){
				if(UpdateFile_2[i][j]!= -1.0 && UpdateFile_2[i][j]!=-2.0)
				{
					if(j == select_j){
						if(UpdateFile_1[i][select_i] >= UpdateFile_1[i][select_j])
							UpdateFile_2[i][j] = UpdateFile_1[i][select_j];
						else
							UpdateFile_2[i][j] = UpdateFile_1[i][select_i];
							
					}
					
					if(i == select_j){
						if(UpdateFile_1[select_i][j] >= UpdateFile_1[select_j][j])
							UpdateFile_2[i][j] = UpdateFile_1[select_j][j];
						else 
							UpdateFile_2[i][j] = UpdateFile_1[select_i][j];
					}
				}
			}
		}
				
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++)
			{
				UpdateFile_1[i][j] = UpdateFile_2[i][j];
			}
		}
	}
	/**
	 * ּҰ ã   ̹  ִ밪(MAX) renewalǴ ̺  .
	 * @param select_i ּҰ ִ  ּ
	 * @param select_j ּҰ ִ  ּ
	 * @throws Exception
	 */
	public void make_Table_using_MAX(int select_i, int select_j) throws Exception{
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++)
			{
				// -1 ƴ ͸ üũ 
				if(UpdateFile_2[i][j]!= -1.0)
				{
					if(i == select_i)
						UpdateFile_2[i][j]= (float)-2.0;	
															
					if(j == select_i)
						UpdateFile_2[i][j]= (float)-2.0;
										
				}	
			}
		}
		
		for(int i=0;i<Data_Count;i++){
			for(int j=0; j<Data_Count;j++){
				if(UpdateFile_2[i][j]!= -1.0 && UpdateFile_2[i][j]!=-2.0)
				{
					if(j == select_j){
						if(UpdateFile_1[i][select_i] >= UpdateFile_1[i][select_j])
							UpdateFile_2[i][j] = UpdateFile_1[i][select_i];
						else
							UpdateFile_2[i][j] = UpdateFile_1[i][select_j];
							
					}
					
					if(i == select_j){
						if(UpdateFile_1[select_i][j] >= UpdateFile_1[select_j][j])
							UpdateFile_2[i][j] = UpdateFile_1[select_i][j];
						else 
							UpdateFile_2[i][j] = UpdateFile_1[select_j][j];
					}
				}
			}
		}
				
		for(int i=0;i<Data_Count;i++){
			for(int j=0;j<Data_Count;j++)
			{
				UpdateFile_1[i][j] = UpdateFile_2[i][j];
			}
		}
	}
	/**
	 * հ ǥ Ѵ.
	 * @param cmp_i ׷  .  ࿡ ִ ̹  
	 * @param cmpNum ؾ  ̹ 
	 * @throws Exception
	 */
	public void cal_Average(int cmp_i,int cmpNum) throws Exception{
				
		store_i = new int[cmpNum] ;
		store_j = new int[cmpNum];
		int setCnt = 0;
	
		g_average = -3;
		g_stand = -3;
		if(cmpNum != 0)
		{
			if(cmpNum == 1)
			{
				System.out.println("0.0");
				g_average = 0;
				g_stand = 0;
			}
			else if(cmpNum > 1)
			{
				for(int j=0;j<Data_Count;j++){
				if(store_temp[cmp_i][j] !=0){
					store_i[setCnt] = store_temp[cmp_i][j];
					setCnt++;
					}
				}
				averNum=0;
				for(int i =0;i<setCnt;i++)
				{
					averNum +=i;
					store_j[i]=store_i[i];
					System.out.println(store_j[i]);
				}
				float sum=0;	//  
				float standSum=0;	// ǥ 
				for(int i=0;i<setCnt;i++){
					for(int j=0;j<setCnt;j++){
						if(i < j){
							//sum =0;
							sum += SimilarData[store_i[i]-1][store_j[j]-1];
							standSum += SimilarData[store_i[i]-1][store_j[j]-1]*SimilarData[store_i[i]-1][store_j[j]-1];
							System.out.println(store_i[i]+" "+store_j[j]+" "+sum);
							//++System.out.println(store_i[i]+" "+store_j[j]+" "+standSum);
							g_average = sum;
							g_stand = standSum;
							//System.out.println("׷  : "+setCnt+" "+"׷:"+g_average);
						}
					}
				}
			}
		}
		else{
			System.out.println("-1.0");
			g_average = -3;
		}
}	
	
	/**
	 * Ŭ͸   󸶳  Դ ˻Ѵ.
	 * @throws Exception
	 */
	public void accuracy_Check() throws Exception{
		
		int cmpNum=0;
		int cmp_i=0;
		float average_temp=0;
		float stand_temp=0;
		float total_average=0;
		float total_stand = 0;
		//float Average = 0;
		for(int i=0;i<Data_Count;i++){
			cmpNum=0;
			for(int j=0;j<Data_Count;j++){
				if(store_temp[i][j] != 0){
					cmp_i=i;
					cmpNum ++;
				}
			}
			//++System.out.println(cmpNum);	
			//++System.out.println(" ");
			cal_Average(cmp_i,cmpNum);
			average_temp = g_average;
			stand_temp = g_stand;
			//System.out.println("׷ոϰ");
			if((average_temp > 0) && (stand_temp > 0))
			{
				average_temp = average_temp/averNum;	// ׷ 
				stand_temp = (float) Math.sqrt(stand_temp/averNum - average_temp*average_temp);	// ׷ ǥ
				System.out.println("====================");
				System.out.println(" ׷  : "+average_temp);
				total_average += average_temp;
				System.out.println(" ׷  : "+stand_temp);
				total_stand +=stand_temp;
			}
			
		}
		//++System.out.println(total_average);
		System.out.println("====================");
		System.out.print("   : ");
		total_average = total_average/ClusterNum;
		total_stand = total_stand/ClusterNum;
		System.out.println(total_average);
		System.out.print(" ǥ  : ");
		System.out.println(total_stand);
		//Average = total_average;
  }	
}
