package net.kldp.cats.core;

/**
 *  ȭ ü  Ŭ
 * 
 * @author sjkim
 * @history 2006 7 28
 */
public class QuantizationFactory {
  /**
   * 
   * @param n1 ù° ä   
   * @param n2 ι° ä  
   * @param n3 ° ä  
   * @return  ȭ ü ȯѴ. 
   */
	static Quantization quant;
  public static Quantization makeSimpleQuantization(int n1, int n2, int n3) {
     quant =  new Quantization();
    quant.numOfBins1st = n1;
    quant.numOfBins2nd = n2;
    quant.numOfBins3rd = n3;
    quant.channel1st = new int[256];
    quant.channel2nd = new int[256];
    quant.channel3rd = new int[256];
    quant.table = new int[n1][n2][n3];
    
    for (int i = 0; i < 256; i++) {
      quant.channel1st[i] = i * n1 / 256; 
    }
    for (int i = 0; i < 256; i++) {
      quant.channel2nd[i] = i * n2 / 256; 
    }
    for (int i = 0; i < 256; i++) {
      quant.channel3rd[i] = i * n3 / 256; 
    }
    
    for (int i = 0; i < n1; i++) {
      for (int j = 0; j < n2; j++) {
        for (int k = 0; k < n3; k++) {
          quant.table[i][j][k] = 
            i * n2 * n3 + j * n3 + k;
        }
      }
    }
    return quant;
  }
  
}
