package net.kldp.cats.ui.FileExplorer;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;

import javax.swing.JList;

import net.kldp.cats.ui.MainFrame;
import net.kldp.cats.ui.ThumbsDB;

/**
 * 丮 ( 丮,  ) ȭ鿡 ֱ  Ŭ
 * 
 * @see FileListModel
 * 
 * @author sjkim
 * 
 * @history 2006-08-12 
 * @history 2006-08-17
 * MainFrame Ŭ   ֵ  ͸ .
 * ڰ ƴ setMain(MainFrame frame) ޼ҵ带 , MainFrame
 *  ޼ҵ带 ȣؾ Ѵ.
 * .
 * class MainFrame ... {
 * ...
 *   public void SomeMethod() {
 *     ...
 *     fileList = new FileList();
 *     fileList.setMain(this);
 * ...
 * 콺 Ŭϸ  â    ȭ鿡 ش.
 * ׷ ListSelectionListener ̽ ּó ߴ.
 * @history 2006-08-27 FileRender ü .
 * FileRenerer ü ̸ ͺ̽   ִ.
 * @history 2006-09-01 FileExplorer Ű ű.
 */
public class FileList extends JList
                      implements MouseListener { //,
                                 // ListSelectionListener {
  MainFrame main;
  
  public FileList() {
    super(new FileListModel());
    init();
  }

  public FileList(FileListModel dataModel) {
    super(dataModel);
    init();
  }
  
  private void init() {
    setLayoutOrientation(JList.HORIZONTAL_WRAP);
    setCellRenderer(new FileRenderer(this));
    setVisibleRowCount(-1);
    // getSelectionModel().addListSelectionListener(this);
    addMouseListener(this);
  }
  
  public void setMain(MainFrame frame) {
    main = frame;
  }
  
  public ThumbsDB getThumbsDB() {
    return ((FileListModel) getModel()).thumbsDB;
  }
  
  public void mouseClicked(MouseEvent e) {
    if (2 <= e.getClickCount()) {
      JList list = (JList)e.getSource();
      System.out.println(list.getSelectedValue());
      if (null != main) {
        main.showImage((File) getSelectedValue());
      }
    }
  }
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
  
  /*
  public void valueChanged(ListSelectionEvent e) {
    if (e.getValueIsAdjusting()) {
      if (null != main) {
        main.showImage((File) getSelectedValue());
      }
    }
  }
  */
}
