package net.kldp.cats.ui.ResultViewer;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JList;

/**
 *  з   ׷ ŭ Ʈ ش.
 * . ׷찳 3
 * ׷ 1 
 * ׷ 2 
 * ׷ 3 
 * ̶ ׷ ̸ ȭ鿡 ǥѴ.
 * ׷ ̸ 콺 Ŭϸ ׷캰  ش.
 * @see ResultPanel, GroupListModel
 * @author sjkim
 * @history 2006-09-01 
 */
public class GroupList extends JList
                       implements MouseListener {

  protected ResultPanel main;
  
  public GroupList() {
    super(new GroupListModel());
    init();
  }

  public GroupList(ResultPanel panel, GroupListModel dataModel) {
    super(dataModel);
    main = panel;
    init();
  }
  
  private void init() {
    setLayoutOrientation(JList.HORIZONTAL_WRAP);
    setVisibleRowCount(-1);
    addMouseListener(this);
  }
  
  public void mouseClicked(MouseEvent e) {
    JList list = (JList)e.getSource();
    GroupListModel model = (GroupListModel) getModel();
    main.showPicture(model.getFileList(),
        model.getGroup(list.getSelectedIndex()));
  }
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
  
}
