package net.kldp.cats.ui.ResultViewer;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.AbstractListModel;

/**
 *  ׷ Ʈ Ѵ.
 * 
 * ǻ.
 * ο ׷ ȣ 0  ȭ鿡 ̴ ׷ ȣ 
 * 1 Ѵ.  1 ׷쿡  ȣ ˷
 * getGroup(0) ̴.
 * 
 * @see GroupList
 * @author sjkim
 * @history 2006-09-01  
 */
public class GroupListModel extends AbstractListModel {
  protected String[] fileList = null;
  protected int[][] groupList = null;
  protected Vector vector;
  
  public GroupListModel() {
    super();
    init();
  }
  
  public GroupListModel(String listFilename, String groupListFilename) {
    super();
    try {
      fileList = readFileList(listFilename);
      groupList = readGroupList(groupListFilename);
      init();
    } catch (IOException e) {
      e.printStackTrace();
    }
  }
  
  private void init() {
    if (null != fileList && null != groupList) {
      vector = new Vector();
      for (int i = 1; i <= groupList.length; i++)
      vector.add("׷  " + i + " ");
    } else {
      vector = null;
    }
  }
  
  /**
   * ()ϸƮ д´.
   * @param fname ()ϸƮ()
   * @return  ̸ Ʈ 迭
   * @throws IOException   Ͽ.
   */    
  public String[] readFileList(String fname) throws IOException {
    String[] list = null;
    if (null != fname) {
      FileReader fr = new FileReader(fname);
      BufferedReader br = new BufferedReader(fr);
      String aLine = null;
      int idx=1, size;
      aLine = br.readLine();
      size = Integer.parseInt(aLine);
      list = new String[size+1];
      while (null != (aLine=br.readLine())) {
        list[idx++] = aLine;
      }    
      br.close();
      fr.close();
    }
    return list;
  }
  
  /**
   * з  (׷츮Ʈ) д´.
   * @param fname ׷츮Ʈ()
   * @throws IOException   Ͽ.
   */
  public int[][] readGroupList(String fname) throws IOException {
    int[][] groupList = null;
    if (null != fname) {
      FileReader fr = new FileReader(fname);
      BufferedReader br = new BufferedReader(fr);
      String aLine = null;
      int size, group;
      StringTokenizer st = null;
      aLine = br.readLine();
      size = Integer.parseInt(aLine);
      groupList = new int[size][];
      group = 0;
      while (null != (aLine=br.readLine())) {
        st = new StringTokenizer(aLine);
        if (st.hasMoreTokens()) {
          groupList[group] = new int[st.countTokens()];
        }
        int i = 0;
        while (st.hasMoreTokens()) {
          groupList[group][i++] = Integer.parseInt(st.nextToken());
        }
        group++;
      }    
      br.close();
      fr.close();
    }
    return groupList;
  }
  
  /**
   *  ̸ Ʈ ´.
   * @return  ̸ Ʈ(1 )
   */
  public String[] getFileList() {
    return fileList;
  }
  
  /**
   *  ׷쿡   ȣ 迭 ´.
   * @param index ׷ ȣ (0 )
   * @return  ȣ ׷(迭)
   */
  public int[] getGroup(int index) {
    return groupList[index];
  }
  
  /** @override */
  public Object getElementAt(int index) {
    if (null != vector) {
      return vector.get(index);
    } else {
      return null;
    }
  }

  /** @override */
  public int getSize() {
    if (null != vector) {
      return vector.size();
    } else {
      return 0;
    }
  }  
}
