package net.kldp.cats.ui.ResultViewer;
import java.awt.Dimension;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.util.Vector;

import javax.swing.JList;
import javax.swing.ListModel;

import net.kldp.cats.ui.ThumbsDB;

/**
 *   ׷쿡   ̸ ȭ鿡 ش.
 * 
 * @see PictureListModel, ThumbsDB
 * @author sjkim
 * @history 2006-09-01 
 */
public class PictureList extends JList {

  protected ThumbsDB thumbsDB;
  
  public PictureList() {
    super(new PictureListModel());
    init();
  }

  public PictureList(PictureListModel dataModel, ThumbsDB thumbs) {
    super(dataModel);
    thumbsDB = thumbs;
    init();
  }
  
  private void init() {
    setLayoutOrientation(JList.HORIZONTAL_WRAP);
    setCellRenderer(new PictureRenderer(this));
    setVisibleRowCount(-1);
  }
  
  public ThumbsDB getThumbsDB() {
    return thumbsDB;
  }  
}
