package net.kldp.cats.ui.ResultViewer;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import javax.swing.border.Border;

/**
 *   ̸ ȭ鿡 ش.
 * 
 * FileRenderer .
 * FileRenderer  ü ̸ ȭ鿡 ְ,
 * PictureRendere  ̸(Ʈ ü) ̸ ȭ鿡 ش.
 * 
 * ǻ.
 *  ϸ ؾ Ѵ.
 * 
 * @see PictureList, ThumbsDB, FileRenderer
 * @author sjkim
 * @history 2006-09-01 
 */
public class PictureRenderer extends JLabel implements ListCellRenderer {
  /** ̸ ͺ̽ ϱ  */
  protected PictureList pictureList;
  /** 콺  丮 Ǵ    ׸   ׵θ */
  public final static Border border =
    BorderFactory.createLineBorder(Color.BLACK);

  public PictureRenderer(PictureList pictureList) {
    super();
    init();
    this.pictureList = pictureList;
  }
  
  /** ʱȭ */
  private void init() {
    setOpaque(false);
    setHorizontalAlignment(JLabel.CENTER);
    setVerticalAlignment(JLabel.CENTER);
    setBackground(Color.WHITE);
    setPreferredSize(new Dimension(100, 115));
    setVerticalTextPosition(JLabel.BOTTOM);
    setHorizontalTextPosition(JLabel.CENTER);
  }

  /** @override */
  public Component getListCellRendererComponent(JList list,
    Object value, int index,
    boolean isSelected, boolean cellHasFocus) {
    if (isSelected) {
      setBorder(border);
    } else {
      setBorder(null);
    }
    loadThumb((String)value);
    return this;
  }
  
  /**
   * @param file 
   */
  protected void loadThumb(String pictureName) {
    String nameTail = 
      pictureName.substring(pictureName.lastIndexOf(File.separator) + 1,
          pictureName.length());
    setText(nameTail);
    setToolTipText(nameTail);
    setIcon(pictureList.getThumbsDB().getIcon(nameTail));
  }  
}